/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidMacroException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
 * This class contains a MAcro that describes the attributes for the Ophthalmic Axial Length Quality Metric.
 * @author saloni
 *
 */
public class OphthalmicAxialLengthQualityMetricMacro extends Macro  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor constructs a Macro with specified Data Set.
	 * @param objDataSet Collection of Data Elements 
	 */
	public OphthalmicAxialLengthQualityMetricMacro(IDataSet objDataSet)
	{
		super(objDataSet);
	}

	/**
	 * This constructor constructs a Macro with specified Data Set and Dictionary Reader
	 * @param objDataSet specifies the DataSet
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public OphthalmicAxialLengthQualityMetricMacro(IDataSet objDataSet,IDictionaryReader objDictionaryReader)
	{
		super(objDataSet,objDictionaryReader);
	}

	/**
	 * This constructor constructs a Macro with the specified Item
	 * @param objItem specifies instance of Item class
	 */
	public OphthalmicAxialLengthQualityMetricMacro(IItem objItem)
	{
		super(objItem);
	}

	/**
	 * This constructor constructs a Macro with the specified Item and DictionaryReader
	 * @param objItem specifies instance of Item class
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public OphthalmicAxialLengthQualityMetricMacro(IItem objItem,IDictionaryReader objDictionaryReader)
	{
		super(objItem, objDictionaryReader);
	}

	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro
	 * @return boolean - Success -true, Failure -false.
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate() throws InvalidMacroException
	{
		if(iMacroLevel == DicomConstants.DCM_MODULE_LEVEL_MACRO)
			return validate(objIDataSet);
		return false;
	}

	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro that are present in the DataSet
	 * @param objIDataSet collection of DataElements
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate(IDataSet objIDataSet) throws InvalidMacroException
	{
		try{
			if(!objIDataSet.isPresent(0x0040,0xA043))
				throw new MandatoryMissingException("0040,A043");
			else if(!objIDataSet.isPresent(0x0040,0xA30A))
				throw new MandatoryMissingException("0040,A30A");
			else if(!objIDataSet.isPresent(0x0040,0x08EA))
				throw new MandatoryMissingException("0040,08EA");
			else
				((ReferencedSeriesSequence)objIDataSet.getDataForTag(0x0008,0x1115)).validate();
		}
		catch(MandatoryMissingException mme)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(mme.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),mme);
		}
		catch( ValidationException ve)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ve.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),ve);
		}
		return true;
	}
	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro that are present in the DataSet
	 * @param objIItem collection of DataElements in a sequence
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public static boolean validate(IItem objIItem) throws InvalidMacroException
	{
		try
		{  
			//validate condition here
			if(!objIItem.contains(0x0040,0xA043))
				throw new MandatoryMissingException("0040,A043");
			if(!objIItem.contains(0x0040,0xA30A))
				throw new MandatoryMissingException("0040,A30A");
			if(!objIItem.contains(0x0040,0x08EA))
				throw new MandatoryMissingException("0040,08EA");
		}
		catch( ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new InvalidMacroException(KeratometricMeasurementsMacro.class.getSimpleName(),ce); 
		}
		catch( MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new InvalidMacroException(KeratometricMeasurementsMacro.class.getSimpleName(),me);
		}
		return true;
	}
	/**
	 * Retrieves pre-initialized object of Concept Name Code Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return ConceptNameCodeSequence - instance of Concept Name Code Sequence. 
	 */
	public ConceptNameCodeSequence getConceptNameCodeSequence()
	{
		ConceptNameCodeSequence objConceptNameCodeSequence = null;
		IDataElement objIDataElement =  getDataElement(0x0040,0xA043);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objConceptNameCodeSequence = (ConceptNameCodeSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objConceptNameCodeSequence = (ConceptNameCodeSequence)objDicomV3Factory.createSequence(0x0040,0xA043, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0040,0xA043, objConceptNameCodeSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0040,0xA043, DicomConstants.DCM_DT_SQ, objConceptNameCodeSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objConceptNameCodeSequence;
	}
	/**
	 * Sets NumericValue.
	 * @param strArrNumericValue String value of Numeric Value.
	 */
	public void setNumericValue(String[] strArrNumericValue)
	{
		/*Accept NumericValue in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0040,0xA30A, strArrNumericValue,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0040,0xA30A,DicomConstants.DCM_DT_DS, strArrNumericValue);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves NumericValue.
	 * @return String - value of NumericValue.
	 */
	public String[] getNumericValue()
	{
		Object objValue = getValue(0x0040,0xA30A);
		if(objValue != null)
			return (String[])objValue;
		return null;
	}
	/**
	 * Retrieves pre-initialized object of Measurement Units CodeSequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return MeasurementUnitsCodeSequence - instance of Measurement Units CodeSequence. 
	 */
	public MeasurementUnitsCodeSequence getMeasurementUnitsCodeSequence()
	{
		MeasurementUnitsCodeSequence objMeasurementUnitsCodeSequence = null;
		IDataElement objIDataElement =  getDataElement(0x0040,0x08EA);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objMeasurementUnitsCodeSequence = (MeasurementUnitsCodeSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objMeasurementUnitsCodeSequence = (MeasurementUnitsCodeSequence)objDicomV3Factory.createSequence(0x0040,0x08EA, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0040,0x08EA, objMeasurementUnitsCodeSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0040,0x08EA, DicomConstants.DCM_DT_SQ, objMeasurementUnitsCodeSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objMeasurementUnitsCodeSequence;
	}
	
}
